export default class MarkdownEditor {
    textbox: HTMLTextAreaElement;
    config: {
        enableAutoCompletion: boolean;
        bracketMatchPairs: ({
            enabled: boolean;
            left: string;
            right: string;
            backspace?: undefined;
            moveBack?: undefined;
            trigger?: undefined;
            needLeftMatch?: undefined;
            rollback?: undefined;
        } | {
            enabled: boolean;
            left: string;
            right: string;
            backspace: string;
            moveBack: number;
            trigger: string;
            needLeftMatch: boolean;
            rollback?: undefined;
        } | {
            enabled: boolean;
            left: string;
            right: string;
            moveBack: number;
            rollback: string;
            trigger: string;
            needLeftMatch: boolean;
            backspace?: undefined;
        })[];
    };
    hotKeyMap: {
        key: string;
        action: (editor: MarkdownEditor) => void;
    }[];
    private disabled;
    constructor(box: HTMLTextAreaElement);
    focusEditor(): void;
    getSelection(): string;
    hasSelection(): boolean;
    clearSelectionToStart(): void;
    clearSelectionToEnd(): void;
    replaceSelectionWith(replacement: string): void;
    wrapSelectionWith(prefix: string, suffix: string, lineByline: boolean): void;
    wrapSelectionWithGenerator(prefixGenerator: (n: number) => string, suffixGenerator: (n: number) => string, lineByline: boolean): void;
    getCurrentLine(): string;
    getStringRelativeToCaret(offset: number): string;
    insertToCaret(value: string): void;
    moveCaretBy(count: number): void;
    getDraftKey(app: string, userId: string, postId: number): string;
    saveDraft(app: string, userId: string, postId: number): void;
    loadDraft(app: string, userId: string, postId: number): void;
    removeDraft(app: string, userId: string, postId: number): void;
    getConfigKey(app: string, userId: string): string;
    saveConfig(app: string, userId: string): void;
    loadConfig(app: string, userId: string): void;
    bracketMatch(input: string): boolean;
    bold(): void;
    link(): void;
    quote(): void;
    code(): void;
    collapsibleCodeBlock(): void;
    taskLists(): void;
    table(col?: number, row?: number): void;
    numberedList(): void;
    bulletList(): void;
    buildTable(rows: string[][]): void;
    formatTable(rows: string[][]): string[][];
    alignTable(rows: string[][]): string[][];
    increaseIndent(): void;
    decreaseIndent(): void;
    isPastingTable(data: DataTransfer): boolean;
    isPastingCode(data: DataTransfer): boolean;
    onKeydown(e: KeyboardEvent): boolean;
    onPaste(e: ClipboardEvent): void;
}
export declare function isCodeBlockSpecialCase1(node: any): boolean;
export declare function isCodeBlock(node: any): boolean;
